#include <iostream>
#include "flatbuffers/flatbuffers.h"
#include "event_generated.h"

void DeserializeUnion(uint8_t* data)
{
	int deBufSize = data[0];
	flatbuffers::Verifier verifier1(data + 4, deBufSize);
	bool res = MyEvent::VerifyEventHolderBuffer(verifier1);
	if (res)
	{
		auto eventHolder = MyEvent::GetEventHolder(data + 4);
		if (eventHolder->event_type() == MyEvent::EventCmd_EventStart)
		{
			const MyEvent::EventStart* e = eventHolder->event_as<MyEvent::EventStart>();
			std::cout << "MyEvent::EventStart  " << "̵ : " << e->id() << std::endl;
			std::cout << "MyEvent::EventStart  " << "Ÿ : " << e->time() << std::endl;
		}
		else if (eventHolder->event_type() == MyEvent::EventCmd_EventEnd)
		{
			const MyEvent::EventEnd* e = eventHolder->event_as<MyEvent::EventEnd>();
			std::cout << "̵ : " << e->id() << std::endl;
			std::cout << "Ÿ : " << e->message()->c_str() << std::endl;
		}
	}
}

void UnionSample_Satart(int id, float startTime)
{
	flatbuffers::FlatBufferBuilder builder;

	//ȭ serialize
	auto startOffset = MyEvent::CreateEventStart(builder, id, startTime);
	auto rootOffset = MyEvent::CreateEventHolder(builder, MyEvent::EventCmd_EventStart, startOffset.Union());
	
	builder.FinishSizePrefixed(rootOffset);
	
	auto data = builder.GetBufferPointer();
	auto bufSize = builder.GetSize();

	flatbuffers::Verifier verifier(data, bufSize);
	bool ok = MyEvent::VerifySizePrefixedEventHolderBuffer(verifier);
	if (ok)
	{
		DeserializeUnion(data);
	}
}

void UnionSample_End(int id, std::string msg)
{
	flatbuffers::FlatBufferBuilder builder;

	//ȭ serialize
	auto offset = MyEvent::CreateEventEnd(builder, id, builder.CreateString(msg.c_str()));
	auto rootOffset = MyEvent::CreateEventHolder(builder, MyEvent::EventCmd_EventEnd, offset.Union());

	builder.FinishSizePrefixed(rootOffset);

	auto data = builder.GetBufferPointer();
	auto bufSize = builder.GetSize();

	flatbuffers::Verifier verifier(data, bufSize);
	bool ok = MyEvent::VerifySizePrefixedEventHolderBuffer(verifier);
	if (ok)
	{
		DeserializeUnion(data);
	}
}

int main()
{
	UnionSample_Satart(2, 88.8f);
	UnionSample_Satart(5, 3.8f);
	std::cout << "--------------------------" << std::endl;
	UnionSample_End(2, "quit2");
	UnionSample_End(5, "quit5");
	getchar();
}